'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.createDeleteHandler = exports.createLoadHandler = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _without = require('lodash/without');

var _without2 = _interopRequireDefault(_without);

var _isArray = require('lodash/isArray');

var _isArray2 = _interopRequireDefault(_isArray);

var _reduce = require('lodash/reduce');

var _reduce2 = _interopRequireDefault(_reduce);

var _merge = require('lodash/merge');

var _merge2 = _interopRequireDefault(_merge);

var _map = require('lodash/map');

var _map2 = _interopRequireDefault(_map);

var _get = require('lodash/get');

var _get2 = _interopRequireDefault(_get);

var _helpers = require('./helpers');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

var defaultLoadOptions = {
  mapToKey: false,
  withLoading: true,
  idsOnly: false
};

var createLoadHandler = exports.createLoadHandler = function createLoadHandler(resourceType, options) {
  return function (state, _ref) {
    var payload = _ref.payload;

    var _defaultLoadOptions$o = _extends({}, defaultLoadOptions, options),
        mapToKey = _defaultLoadOptions$o.mapToKey,
        withLoading = _defaultLoadOptions$o.withLoading,
        idsOnly = _defaultLoadOptions$o.idsOnly;

    var payloadResource = (0, _get2.default)(payload, 'data.' + resourceType, false);

    var mappedResourceType = mapToKey || resourceType;

    // $FlowFixMe
    var nextState = _defineProperty({}, mappedResourceType, idsOnly ? [].concat(_toConsumableArray(state[mappedResourceType]), _toConsumableArray((0, _map2.default)(payloadResource, 'id'))) : (0, _merge2.default)({}, state[mappedResourceType], payloadResource));

    if (withLoading) {
      var addKey = mapToKey ? (0, _helpers.capitalizeFirstLetter)(mapToKey) : '';
      nextState['isLoaded' + addKey] = true;
      nextState['isLoading' + addKey] = false;
    }

    return state.merge(nextState);
  };
};

var createDeleteHandler = exports.createDeleteHandler = function createDeleteHandler(stateKey) {
  return function (state, _ref2) {
    var payload = _ref2.payload;

    var deletedId = (0, _get2.default)(payload, 'deletedId');

    var stateValue = state[stateKey];

    return state.merge(_defineProperty({}, stateKey, (0, _isArray2.default)(stateValue) ? (0, _without2.default)(stateValue, deletedId) : (0, _reduce2.default)(stateValue, function (result, value, key) {
      if (value.id !== deletedId) {
        return _extends({}, result, _defineProperty({}, key, value));
      }
      return _extends({}, result);
    }, {})));
  };
};